From 30b9e1dd08352aa36c91dc962e42f3d042c2925a Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Mon, 6 Feb 2012 15:08:35 -0600
Subject: Edit works

---
 grade/report/quick_edit/classes/datalib.php    |    4 +-
 grade/report/quick_edit/classes/lib.php        |   28 ++++++++++++++--
 grade/report/quick_edit/index.php              |   10 ++++++
 grade/report/quick_edit/lib.php                |    4 ++-
 grade/report/quick_edit/screens/grade/lib.php  |   30 +++++++++++++----
 grade/report/quick_edit/screens/select/lib.php |   42 +++++++++++++++---------
 grade/report/quick_edit/screens/user/lib.php   |   20 +++++++++--
 7 files changed, 106 insertions(+), 32 deletions(-)

diff --git a/grade/report/quick_edit/classes/datalib.php b/grade/report/quick_edit/classes/datalib.php
index 8930e30..3259feb 100644
--- a/grade/report/quick_edit/classes/datalib.php
+++ b/grade/report/quick_edit/classes/datalib.php
@@ -81,10 +81,10 @@ class quick_edit_grade_processor extends post_processor {
             if ($posted == -1) {
                 $finalgrade = null;
             } else {
-                $finalgrade = $posted;
+                $finalgrade = $value;
             }
         } else {
-            $finalgrade = unformat_float($posted);
+            $finalgrade = unformat_float($value);
         }
 
         $errorstr = '';
diff --git a/grade/report/quick_edit/classes/lib.php b/grade/report/quick_edit/classes/lib.php
index ab76819..fc0777e 100644
--- a/grade/report/quick_edit/classes/lib.php
+++ b/grade/report/quick_edit/classes/lib.php
@@ -3,6 +3,14 @@
 require_once $CFG->dirroot . '/grade/report/quick_edit/classes/uilib.php';
 require_once $CFG->dirroot . '/grade/report/quick_edit/classes/datalib.php';
 
+interface selectable_items {
+    public function description();
+
+    public function options();
+
+    public function item_type();
+}
+
 abstract class quick_edit_screen {
     var $courseid;
 
@@ -19,7 +27,7 @@ abstract class quick_edit_screen {
 
         $this->context = get_context_instance(CONTEXT_COURSE, $this->courseid);
 
-        $this->init();
+        $this->init(empty($itemid));
     }
 
     public function format_link($screen, $itemid, $display = null) {
@@ -82,7 +90,7 @@ abstract class quick_edit_screen {
         return get_string('pluginname', 'gradereport_quick_edit');
     }
 
-    public abstract function init();
+    public abstract function init($self_item_is_empty = false);
 
     public abstract function html();
 
@@ -117,6 +125,20 @@ abstract class quick_edit_tablelike extends quick_edit_screen {
             $table->data[] = $this->format_line($item);
         }
 
-        return html_writer::table($table);
+        $button_attr = array('class' => 'quick_edit_buttons');
+        $button_html = implode(' ', $this->buttons());
+
+        $buttons = html_writer::tag('div', $button_html, $button_attr);
+
+        return html_writer::tag('form',
+            html_writer::table($table) . $buttons,
+            array('method' => 'POST')
+        );
+    }
+
+    public function buttons() {
+        $save = html_writer::empty_tag('input', array('type' => 'submit'));
+
+        return array($save);
     }
 }
diff --git a/grade/report/quick_edit/index.php b/grade/report/quick_edit/index.php
index 3f11e5b..667873c 100755
--- a/grade/report/quick_edit/index.php
+++ b/grade/report/quick_edit/index.php
@@ -88,6 +88,16 @@ if ($reportname != $pluginname) {
 
 print_grade_page_head($course->id, 'report', 'quick_edit', $reportname);
 
+if ($data = data_submitted()) {
+    $warnings = $report->process_data($data);
+}
+
+if (!empty($warnings)) {
+    foreach ($warnings as $warning) {
+        echo $OUTPUT->notification($warning);
+    }
+}
+
 echo $report->output();
 
 echo $OUTPUT->footer();
diff --git a/grade/report/quick_edit/lib.php b/grade/report/quick_edit/lib.php
index d136324..5ee857e 100755
--- a/grade/report/quick_edit/lib.php
+++ b/grade/report/quick_edit/lib.php
@@ -63,6 +63,7 @@ class grade_report_quick_edit extends grade_report {
     }
 
     function process_data($data) {
+        return $this->screen->processor()->handle($data);
     }
 
     function process_action($target, $action) {
@@ -81,6 +82,7 @@ class grade_report_quick_edit extends grade_report {
     }
 
     function output() {
-        return $this->screen->html();
+        global $OUTPUT;
+        return $OUTPUT->box($this->screen->html());
     }
 }
diff --git a/grade/report/quick_edit/screens/grade/lib.php b/grade/report/quick_edit/screens/grade/lib.php
index ee7b4c6..f16a1cd 100644
--- a/grade/report/quick_edit/screens/grade/lib.php
+++ b/grade/report/quick_edit/screens/grade/lib.php
@@ -1,12 +1,33 @@
 <?php
 
-class quick_edit_grade extends quick_edit_tablelike {
+class quick_edit_grade extends quick_edit_tablelike implements selectable_items {
 
     private $requires_extra;
 
     private $structure;
 
-    public function init() {
+    public function description() {
+        return get_string('users');
+    }
+
+    public function options() {
+        return array_map(function($user) { return fullname($user); }, $this->items);
+    }
+
+    public function item_type() {
+        return 'user';
+    }
+
+    public function init($self_item_is_empty = false) {
+        $roleids = explode(',', get_config('moodle', 'gradebookroles'));
+
+        $this->items = get_role_users($roleids, $this->context, false, '',
+                'u.lastname, u.firstname', null, $this->groupid);
+
+        if ($self_item_is_empty) {
+            return;
+        }
+
         global $DB;
 
         $params = array(
@@ -14,13 +35,8 @@ class quick_edit_grade extends quick_edit_tablelike {
             'courseid' => $this->courseid
         );
 
-        $roleids = explode(',', get_config('moodle', 'gradebookroles'));
-
         $this->item = grade_item::fetch($params);
 
-        $this->items = get_role_users($roleids, $this->context, false, '',
-            'u.lastname, u.firstname', null, $this->groupid);
-
         $this->requires_extra = !$this->item->is_manual_item();
 
         $this->structure = new grade_structure();
diff --git a/grade/report/quick_edit/screens/select/lib.php b/grade/report/quick_edit/screens/select/lib.php
index be87f26..ec2c258 100644
--- a/grade/report/quick_edit/screens/select/lib.php
+++ b/grade/report/quick_edit/screens/select/lib.php
@@ -2,33 +2,43 @@
 
 // TODO: custom form with group selector
 class quick_edit_select extends quick_edit_screen {
-    public function init() {
+    public function init($self_item_is_empty = false) {
         global $DB;
 
-        $params = array('courseid' => $this->courseid);
-
-        $filter_items = grade_report_quick_edit::only_items();
-
-        $this->grade_items = array_filter(grade_item::fetch_all($params), $filter_items);
-
         $this->item = $DB->get_record('course', array('id' => $this->courseid));
     }
 
     public function html() {
         global $OUTPUT;
 
-        $map = function($item) { return $item->itemname; };
+        $html = '';
+
+        $types = grade_report_quick_edit::valid_screens();
+
+        foreach ($types as $type) {
+            if ($type == 'select') continue;
+
+            $class = grade_report_quick_edit::classname($type);
+
+            $screen = new $class($this->courseid, null, $this->groupid);
+
+            if (!method_exists($screen, 'options')) {
+                continue;
+            }
+
+            $params = array(
+                'id' => $this->courseid,
+                'item' => $screen->item_type(),
+                'group' => $this->groupid
+            );
 
-        $grade_options = array_map($map, $this->grade_items);
+            $url = new moodle_url('/grade/report/quick_edit/index.php', $params);
 
-        $params = array(
-            'id' => $this->courseid,
-            'item' => 'grade',
-            'group' => $this->groupid
-        );
+            $html .= $OUTPUT->heading($screen->description());
 
-        $url = new moodle_url('/grade/report/quick_edit/index.php', $params);
+            $html .= $OUTPUT->single_select($url, 'itemid', $screen->options());
+        }
 
-        echo $OUTPUT->single_select($url, 'itemid', $grade_options, $this->itemid);
+        return $html;
     }
 }
diff --git a/grade/report/quick_edit/screens/user/lib.php b/grade/report/quick_edit/screens/user/lib.php
index da87092..df24974 100644
--- a/grade/report/quick_edit/screens/user/lib.php
+++ b/grade/report/quick_edit/screens/user/lib.php
@@ -1,15 +1,29 @@
 <?php
 
-class quick_edit_user extends quick_edit_tablelike {
+class quick_edit_user extends quick_edit_tablelike implements selectable_items {
 
     private $categories = array();
 
     private $structure;
 
-    public function init() {
+    public function description() {
+        return get_string('gradeitems', 'grades');;
+    }
+
+    public function options() {
+        return array_map(function($item) { return $item->get_name(); }, $this->items);
+    }
+
+    public function item_type() {
+        return 'grade';
+    }
+
+    public function init($self_item_is_empty = false) {
         global $DB;
 
-        $this->user = $DB->get_record('user', array('id' => $this->itemid));
+        if (!$self_item_is_empty) {
+            $this->user = $DB->get_record('user', array('id' => $this->itemid));
+        }
 
         $params = array('courseid' => $this->courseid);
 
-- 
1.7.1


